/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef _MPEG_DEC_H_
#define _MPEG_DEC_H_

#include "general.h"

typedef struct
{
	BOOL fgB2R3DEnable;
	UINT8 u1B2R3DType;
}B2R_3D_INFO;

extern void vMpegSdConnect(UINT8 bchannel, UINT8 fgIsOn);
extern void vMpegHdConnect(UINT8 bchannel, UINT8 fgIsOn);
extern UINT16 u2MpegHdInputWidth(UINT8 bPath);
extern UINT16 u2MpegSdInputWidth(UINT8 bPath);
extern UINT16 u2MpegHdInputValidDataWidth(UINT8 bPath);
extern UINT16 u2MpegSdInputValidDataWidth(UINT8 bPath);

extern UINT16 u2MpegHdInputHeight(UINT8 bPath); 
extern UINT16 u2MpegSdInputHeight(UINT8 bPath);
extern UINT8 u1MpegHdRefreshRate(UINT8 bPath);
extern UINT8 u1MpegSdRefreshRate(UINT8 bPath);
extern UINT32 u4MpegHdRealRefreshRate(UINT8 bPath);
extern UINT32 u4MpegSdRealRefreshRate(UINT8 bPath);

extern UINT8 u1MpegSdInterlace(void);
extern UINT8 u1MpegHdInterlace(UINT8 bPath);
extern UINT8 u1MpegHdSigStatus(UINT8 bPath);
extern UINT8 u1MpegSdSigStatus(UINT8 bPath);
extern UINT16 u2MpegHdHTotal(UINT8 bPath);
extern UINT16 u2MpegSdHTotal(UINT8 bPath);
extern UINT16 u2MpegHdVTotal(UINT8 bPath);
extern UINT16 u2MpegSdVTotal(UINT8 bPath);
extern UINT8 u1MpegHdTiming(UINT8 bPath);
extern UINT8 u1MpegSdTiming(void);
extern UINT8 u1MpegHdClock(UINT8 bPath);
extern UINT8 u1MpegSdClock(UINT8 bPath);

extern UINT32 u4MpegHdQuality(void);
extern UINT32 u4MpegSdQuality(void);
extern UINT8 u1MpegHdColorSpace709(void);
extern UINT8 u1MpegSdColorSpace709(void);
extern UINT8 u1MpegHdColourPrimary(void);
extern UINT8 u1MpegSdColourPrimary(void);
extern UINT8 u1MpegHdTransCharacter(void);
extern UINT8 u1MpegSdTransCharacter(void);
extern UINT8 u1MpegHdMatrixCoeff(void);
extern UINT8 u1MpegSdMatrixCoeff(void);
extern UINT8 u1MpegHdColorDescrip(void);
extern UINT8 u1MpegSdColorDescrip(void);
extern UINT32 u4MpegHdHdeRatio(void);
extern VOID vMpegGet3DInfo(UINT8 u1B2RId,B2R_3D_INFO* prB2R3DInfo);
extern UINT32 u4MpegHdPreciseRefreshRate(UINT8 bPath);
extern UINT32 u4MpegSdPreciseRefreshRate(UINT8 bPath);

extern VOID vMpegInit(void);
extern VOID vMpegInitB2rConf(void);
extern VOID vMpegModeChg(UCHAR ucVdpId);
extern VOID vMpegModeDetDone(UCHAR ucVdpId);

#endif
